﻿-- LGeneral AddOn Options

RT_Options = {
	desc = {
		logGroup = { [0] = "Off", [1] = "Log", [2] = "Auto Create", [3] = "Auto Instance", },        
		logAttendees = { [0] = "Off", [1] = "On event", [2] = "On loot", [3] = "On event (Zone)", },
		logGuild = { [0] = "Off", [1] = "On event (All)",  },
		tooltips = { [0] = "Off", [1] = "Options Only", [2] = "All", },
		autoEvent = { [0] = "Off", [1] = "On mouseover", [2] = "On event", [3] = "Ask Next", },
		export = { [0] = "EQdkp/ML 1.1", [1] = "EQdkp Unknown", [2] = "MLdkp 1.5", [3] = "EQdkp Strict", [4] = "Plain Text", },
		itemopt = {	[0] = "Default", [1] = "Never", [2] = "Always",	},
		rarity = {
			[0] = "|c00ffffffOff|r",
			[1] = "|c009d9d9dPoor|r",
			[2] = "|c00ffffffCommon|r",
			[3] = "|c001eff00Uncommon|r",
			[4] = "|c000070ddRare|r",
			[5] = "|c00a335eeEpic|r",
			[6] = "|c00ff8000Legendary|r",
			[7] = "|c00e6cc80Artifact|r",
        },
		logWipe = {
		    [0] = "Off", [1] = "Log",
		    [2] = "Ask at 10%", [3] = "Ask at 20%",
		    [4] = "Ask at 30%", [5] = "Ask at 40%",
		    [6] = "Ask at 50%",	[7] = "Ask at 60%",
			[8] = "Ask at 70%",	[9] = "Ask at 80%",
		},
	},
}
	

function RT_Options:OnLoad( frame )
	local o,L = KARaidTrackerDB.Options,RaidTracker.L
	local desc = self.desc
	
    RT_OptionsFrameHeaderTitle:SetText(L["Raid Tracker - Options"])
--    RT_OptionsFrameHeaderText:SetText(L["Options for raids, parties, arenas, bgs, and solo."]);    

	local info = {
		{ name="_Section1", title="Logging", type="Frame", class="RT_SectionTemplate", y=-24, opts = nil, desc = "Basic logging options. For group type options such as Raid and Party: Log means log events, items, attendence, and other history at all; Auto Create means allow creation of instances automatically when in this group type; Auto Instance means create a new session during an existing session when entering a new triggerable zone.", },
		{ name="AutoRaid", title="Raids", type="Slider", class="RT_SliderTemplate", opts = desc.logGroup, desc = "Options for logging when in a raid.", },
		{ name="AutoParty", title="Parties", type="Slider", class="RT_SliderTemplate", opts = desc.logGroup, desc = "Options for logging when in a party.", },
		{ name="AutoSolo", title="Solo", type="Slider", class="RT_SliderTemplate", opts = desc.logGroup, desc = "Options for logging when playing solo. For solo loot pickup that passes other filters wil create a session if no session is yet started.", },
		{ name="AutoBattlegroup", title="Battelgroups", type="Slider", class="RT_SliderTemplate", opts = desc.logGroup, desc = "Options for logging when in a battlegroup.", },
		{ name="AutoArena", title="Arenas", type="Slider", class="RT_SliderTemplate", opts = desc.logGroup, desc = "Options for logging when in an arena.", },
		{ name="LogAttendees", title="Attendees", type="Slider", class="RT_SliderTemplate", y=-24, opts = desc.logAttendees, desc = "When and for what to log attendee snapshots. 'On event' logs when a boss is killed on the event created, 'On loot' logs when loot drops and is per loot item, 'On event (Zone)' is same as 'On event' only logs members who are in the zone.", },
		{ name="LogGuild", title="Guild", type="Slider", class="RT_SliderTemplate", opts = desc.logGuild, desc = "Adds guildies as though they were raid members to the raid on an event (boss kill). 'On event (all)' adds all guildies or can choose by guild rank, where is the minimum rank to add (Ex: officer or higher, raider or hiher). One use for this is showing who was on standby.", },
		{ name="LogWipe", title="Wipes", type="Slider", class="RT_SliderTemplate", opts = desc.logWipe, desc = "Logs a wipe a a certain percentage death for group, used by some DKP system. Or is jsut nice to see popup to remind you or let you know. :)", },
		{ name="_Section2", title="Item Quality", type="Frame", class="RT_SectionTemplate", opts = nil, desc = "Item quality filters. Minimum means that item rarity or higher. Maximum means that item rarity or lower.", },
		{ name="LogItems", title="Min to log", type="Slider", class="RT_SliderTemplate", opts = desc.rarity, desc = "Minimum item quality to log. If an item is filtered here will be ignored compltely, such as not triggering session start on solo, not allow for /rt itemadd etc... Items can be filtered per item in item options where default uses this setting, always is always and never is never.", },
		{ name="CostGet", title="Min to ask cost", type="Slider", class="RT_SliderTemplate", opts = desc.rarity, desc = "Minimum item quality get cost from external cost system when an item is looted, such as HellbenderDKP and ItemLevelDKP. This happenes before Ask Cost. This can be changed for individual items in Item Options.", },
		{ name="CostAsk", title="Min to get cost", type="Slider", class="RT_SliderTemplate", opts = desc.rarity, desc = "Minimum quality to Ask for cost using a popup box as loot is received. Get Cost always happens before Ask Cost. This can be changed for individual items in Item Options.", },
		{ name="StackItems", title="Max to stack", type="Slider", class="RT_SliderTemplate", opts = desc.rarity, desc = "Maximum quality to stack items, rather than log individualy. This can be changed for individual items in Item Options.", },
		{ name="_Section3", title="Advanced", type="Frame", class="RT_SectionTemplate", opts = nil, desc = "Advanced user options.", },
		{ name="ShowTooltips", title="Show Tooltips", type="Slider", class="RT_SliderTemplate", opts = desc.tooltips, desc = "Whether or not to show tooltips.", },
		{ name="AutoEvent", title="Auto Event", type="Slider", class="RT_SliderTemplate", opts = desc.autoEvent, desc = "Changes how the current loot target is determined, to trigger or find the next triggerable boss or trash mob. 'On mouseover' uses your hover target, 'On event uses the event data as in when a bosskill occurs. Ask Next asks you which in a popup. The most stable option is 'On event' but ther are uses for 'On mouseover' if youare havign trouble keeping the loot target.", },
		{ name="EventCooldown", title="Event Cooldown", type="Slider", class="RT_SliderTemplate", opts = nil, desc = "How long to wait in seconds before allowing a non triggerable kill, or trash mob to change the current loot target in RT.  You can see the current [loot target] in the status bar at top of main window, if no target then is considered a trash mob.", },
		{ name="LevelMax", title="Export level", type="Slider", class="RT_SliderTemplate", opts = nil, desc = "this is default platyer level to export and controls what is exported for some export formats.  Does not affect or limit anything goign into the RT DB.", },
		{ name="AutoZone", title="Auto Zone", type="CheckButton", class="RT_CheckBoxTemplate", opts = nil, desc = "Wether or not to allow RT to autimatically determine the zone. If this is off then will have to set zone manually using the right click menus.", },
		{ name="DebugMode", title="Debug Mode", type="CheckButton", class="RT_CheckBoxTemplate", opts = nil, desc = "Putsinto developmetn mode which prints debug messages omng other things.", },
		{ name="ExportFormat", title="Export Format", type="Slider", class="RT_SliderTemplate", opts = desc.export, desc = "Format used when exporting a raid by choosing export right cick menu.", },
	}
--[[
    local s,f,flast = frame:GetName(),nil,frame
   	for k,v in pairs(info) do
		f = CreateFrame(v.type, nil, frame, v.class)
		f:SetPoint("TOP", flast, "BOTTOM", v.ox or 0, v.oy or 0)
		<Slider name="$parent_AutoRaid" inherits="RT_SliderTemplate" minValue="0" maxValue="3" valueStep="1">
				<Anchors>
					<Anchor point="TOP" relativeTo="$parent__Section1" relativePoint="BOTTOM" />
				</Anchors>
			</Slider>

		f:SetFrameStrata("BACKGROUND")
		f:SetWidth(128) -- Set these to whatever height/width is needed 
		f:SetHeight(64) -- for your Texture

		local t = f:CreateTexture(nil,"BACKGROUND")
		t:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Factions.blp")
		t:SetAllPoints(f)
		f.texture = t

		f:SetPoint("CENTER",0,0)
		f:Show()
		
		flast = f
	end
]]
	RT_Templates:InitWidgets( frame, RT_Button, info )
end


function RT_Options:OnShow( frame )
	if self.OnLoad then self:OnLoad(frame); self.OnLoad = nil end
	local o,L = KARaidTrackerDB.Options,RaidTracker.L
    		
	local count = table.maxn(self.desc.logGuild)
	for i = 2, count do tremove(self.desc.logGuild, i) end	
	if IsInGuild() then
		GuildRoster(); count = max(GuildControlGetNumRanks(), 1)
		for i = 2, count do	self.desc.logGuild[i] = "("..i..") "..GuildControlGetRankName(i) end
	end
	RT_OptionsFrame_LogGuild:SetMinMaxValues(0, count)

 	for k,v in pairs(RaidTracker._store.defaults.Options) do
 		local e,opt = getglobal("RT_OptionsFrame_" .. k),o[k]
 		if e then
			if e.GetMinMaxValues then local _,x = e:GetMinMaxValues(); if opt > x then opt = x end end
 			if e.SetChecked then e:SetChecked(opt) else e:SetValue(opt) end 
 		end
 	end
end


function RT_Options:OnSave( frame )
 	local o = KARaidTrackerDB.Options
 	
 	for k,v in pairs(RaidTracker._store.defaults.Options) do
 		local e = getglobal("RT_OptionsFrame_" .. k) 	
 		if e then
 			v = e.GetChecked and ((e:GetChecked() == 1) and 1 or 0) or e:GetValue()
 			if o[k] ~= v then o[k] = v end
 		end
 	end
	
	KA_RaidTracker_Update()
	KA_RaidTracker_UpdateView()
end